%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Image Searching by Histogram comparison          %
%   Bo Han                                            %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function imageSearch(query, comparison)

%read all images in the current folder
d=dir('*.jpg');
for i=1:length(d)
    imgname{i} = d(i).name;
    img=imread(imgname{i});
    % extract feature vector (histogram) for each image
    features(i,:)=imhist(img,256)';
end


%show original images
figure;
showPitures(query, imgname,[1:9]);

%show histogram for each picture
figure;
for i=1:length(imgname)
        subplot(3,3,i);
        if i ~= query
            bar(features(i,:));
            title(imgname{i});
        else
            bar(features(i,:));
            title('query image');
        end
end

query_feature=features(query,:);
% feature comparison
for i = 1:length(imgname)
    C(i) = vectorComp(query_feature , features(i,:),comparison);
end

% rank the picutures by the comparison values
[top index] = sort(C)

% show the ranked result
figure;
showPitures(query, imgname,index);
return

